"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/// <reference path="./externals.d.ts" />
var Pages;
(function (Pages) {
    var PageFactory = /** @class */ (function () {
        function PageFactory() {
            this.container = document.body;
        }
        Object.defineProperty(PageFactory, "Instance", {
            get: function () {
                if (!PageFactory.instance) {
                    PageFactory.instance = new PageFactory();
                }
                return PageFactory.instance;
            },
            enumerable: true,
            configurable: true
        });
        PageFactory.prototype.createPageContent = function (location) {
            var element;
            var uri = new Utils.UriHelper(location);
            var path = uri.Pathname.toLocaleLowerCase();
            if (path.indexOf("index") >= 0 || path === "/") {
                element = React.createElement(Pages.Index, {});
                if (element && this.container) {
                    ReactDOM.render(element, this.container);
                }
            }
        };
        return PageFactory;
    }());
    Pages.PageFactory = PageFactory;
})(Pages || (Pages = {}));
/// <reference path="./externals.d.ts" />
var Utils;
(function (Utils) {
    var UriHelper = /** @class */ (function () {
        function UriHelper(url) {
            this.queryString = {};
            this.url = url;
            this.anchorElement = document.createElement('a');
            this.anchorElement.href = url;
            this.initQueryString();
        }
        UriHelper.prototype.initQueryString = function () {
            var _this = this;
            if (!this.anchorElement.search || this.anchorElement.search === "") {
                return;
            }
            var queryElemes = this.anchorElement.search.substring(1).split("&");
            _.each(queryElemes, function (item) {
                var itemElems = item.split("=");
                _this.queryString[itemElems[0]] = itemElems[1];
            });
        };
        Object.defineProperty(UriHelper.prototype, "Protocol", {
            get: function () {
                return this.anchorElement.protocol;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UriHelper.prototype, "Hostname", {
            get: function () {
                return this.anchorElement.hostname;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UriHelper.prototype, "Port", {
            get: function () {
                return this.anchorElement.port;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UriHelper.prototype, "Pathname", {
            get: function () {
                return this.anchorElement.pathname;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UriHelper.prototype, "Search", {
            get: function () {
                return this.anchorElement.search;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UriHelper.prototype, "Hash", {
            get: function () {
                return this.anchorElement.hash;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UriHelper.prototype, "Host", {
            get: function () {
                return this.anchorElement.host;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UriHelper.prototype, "QueryString", {
            get: function () {
                return this.queryString;
            },
            enumerable: true,
            configurable: true
        });
        return UriHelper;
    }());
    Utils.UriHelper = UriHelper;
})(Utils || (Utils = {}));
/// <reference path="./frame/externals.d.ts" />
var Components;
(function (Components) {
    var PageContent = /** @class */ (function (_super) {
        __extends(PageContent, _super);
        function PageContent(props) {
            return _super.call(this, props) || this;
        }
        PageContent.prototype.render = function () {
            return (React.createElement("div", { className: "content" },
                "Here we need to place Syncfusion Diagram react component",
                React.createElement("br", null),
                "from definition file -> ../../node_modules/@syncfusion/ej2-react-diagrams/index.d.ts",
                React.createElement("br", null),
                "When you uncoment line 4 in externals.d.ts \"project\" doesn't compile",
                React.createElement("br", null)));
        };
        return PageContent;
    }(React.Component));
    Components.PageContent = PageContent;
})(Components || (Components = {}));
/// <reference path="./frame/externals.d.ts" />
var Components;
(function (Components) {
    var PageFooter = /** @class */ (function (_super) {
        __extends(PageFooter, _super);
        function PageFooter(props) {
            return _super.call(this, props) || this;
        }
        PageFooter.prototype.render = function () {
            return (React.createElement("div", { ref: "header", className: "footer" }));
        };
        return PageFooter;
    }(React.Component));
    Components.PageFooter = PageFooter;
})(Components || (Components = {}));
/// <reference path="./frame/externals.d.ts" />
var Components;
(function (Components) {
    var PageHeader = /** @class */ (function (_super) {
        __extends(PageHeader, _super);
        function PageHeader(props) {
            return _super.call(this, props) || this;
        }
        PageHeader.prototype.render = function () {
            return (React.createElement("div", { ref: "header", className: "header", dangerouslySetInnerHTML: { __html: this.props.title } }, this.props.children));
        };
        return PageHeader;
    }(React.Component));
    Components.PageHeader = PageHeader;
})(Components || (Components = {}));
/// <reference path="./externals.d.ts" />
var Components;
(function (Components) {
    function onLoadApp() {
        if (document && document.location) {
            Pages.PageFactory.Instance.createPageContent(document.location.href);
        }
    }
    document.addEventListener("DOMContentLoaded", onLoadApp);
})(Components || (Components = {}));
/// <reference path="./externals.d.ts" />
var Pages;
(function (Pages) {
    var Index = /** @class */ (function (_super) {
        __extends(Index, _super);
        function Index(props) {
            return _super.call(this, props) || this;
        }
        Index.prototype.render = function () {
            return (React.createElement(React.Fragment, null,
                React.createElement(Components.PageHeader, { title: "Demo Syncfusion Diagram" }),
                React.createElement(Components.PageContent, null),
                React.createElement(Components.PageFooter, null)));
        };
        return Index;
    }(React.Component));
    Pages.Index = Index;
})(Pages || (Pages = {}));
