// npm pack
// npm publish
// npm unpublish htmlreacttypescipttemplate@1.0.6
// netstat -ano | findstr :1444 => findedPidNo
// taskkill /PID <findedPidNo> /F

var argv        = require('yargs').argv;
var fs          = require('fs');
var del         = require('del');
var gulp        = require('gulp');
var sass        = require('gulp-sass');
var concat      = require('gulp-concat');
var open        = require('gulp-open');
var runSequence = require('run-sequence');

var source      = {
    ROOT: process.cwd() + '/../../',
    ORIGIN: '.'
};

var origin = source.ORIGIN;
argv.root == 1 ? origin = source.ROOT : origin = source.ORIGIN;
console.log(origin);



// ------------------------------- Build -------------------------------
// recompile js externals file
gulp.task('compile-js', function () {
    gulp.src([
            origin + '/node_modules/react/umd/react.production.min.js',
            origin + '/node_modules/react-dom/umd/react-dom.production.min.js',
            origin + '/node_modules/classnames/index.js',
            origin + '/node_modules/underscore/underscore-min.js'
        ])
        .pipe(concat('externals.js'))
        .on('error', function (err) { console.log(err.message); })
        .pipe(gulp.dest(origin + '/demo/'));
});

// recompile scss file
gulp.task('compile-scss', function () {
    return gulp.src('./src/app.scss')
        .pipe(sass())
        .on('error', function (err) { console.log(err.message); })
        .pipe(gulp.dest(origin + '/demo/'));
});



// ---------------------------- Postinstall Package ----------------------------
gulp.task('prepare gulp', function (cb) {
    if (origin === source.ROOT) {
        return gulp.src('./scripts/gulpfile.js')
        .pipe(gulp.dest(origin))
    }
    return false
});
  
gulp.task('prepare root', function (cb) {
    if (origin === source.ROOT) {
        return gulp.src(['./favicon.ico', './index.html', './tsconfig.json', './scripts/gulpfile.js'])
        .pipe(gulp.dest(origin + '/'))
    }
    return false;
});
  
gulp.task('prepare frame', function (cb) {
    if (origin === source.ROOT) {
        return gulp.src('./src/**/*')
        .pipe(gulp.dest(origin + '/src'))
    }
    return false
});

gulp.task('build', function(cb) {
    runSequence(['compile-scss', 'compile-js'], ['prepare frame', 'prepare root'], cb)
});



// ---------------------------- Run Page ----------------------------
gulp.task('run', function () {
    var options = {
        uri: 'http://localhost:1333/index.html',
        app: 'chrome'
    };
    gulp.src(__filename)
        .pipe(open(options));
});

gulp.task('default', ['compile']);
