var gulp        = require('gulp');
var sass        = require('gulp-sass');
var concat      = require('gulp-concat');
var open        = require('gulp-open');
var http        = require('gulp-connect');
var port        = 1444;

// ---------------------------- http server ----------------------------
gulp.task('server-start', function () {
    http.server({
        port: port,
        livereload: true,
        root: "./"
    });
});

gulp.task('server-stop', function () {
    http.serverClose();
});



// ------------------------------- Build -------------------------------
gulp.task('compile', function () {
    gulp.start('compile-js');
    gulp.start('compile-scss');
});

// recompile js externals file
gulp.task('compile-js', function () {
    gulp.src([
            './node_modules/react/umd/react.production.min.js',
            './node_modules/react-dom/umd/react-dom.production.min.js',
            './node_modules/classnames/index.js',
            './node_modules/underscore/underscore-min.js'
        ])
        .pipe(concat('externals.js'))
        .on('error', function (err) { console.log(err.message); })
        .pipe(gulp.dest('./demo/'));
});

// recompile scss file
gulp.task('compile-scss', function () {
    return gulp.src('./src/**/*.scss')
        .pipe(sass())
        .on('error', function (err) { console.log(err.message); })
        .pipe(gulp.dest('./demo/'));
});



// ---------------------------- Run Page ----------------------------
gulp.task('run', function () {
    var options = {
        uri: 'http://localhost:' + port + '/index.html',
        app: 'chrome'
    };
    gulp.src(__filename)
        .pipe(open(options));
});

gulp.task('default', ['run']);