/// <reference path="./externals.d.ts" />

module Pages {
    export interface IPageFactoryExtender {
        createPageContent(path: string): React.ReactElement<any>;
    }

    export class PageFactory {
        private static instance: PageFactory;
        private readonly container: HTMLElement;

        constructor() {
            this.container = document.body;
        }

        static get Instance(): PageFactory {
            if (!PageFactory.instance) {
                PageFactory.instance = new PageFactory();
            }
            return PageFactory.instance;
        }

        createPageContent(location: string) {
            let element: React.ReactElement<any>;
            const uri = new Utils.UriHelper(location);
            const path = uri.Pathname.toLocaleLowerCase();

            if (path.indexOf("index") >= 0 || path === "/") {
                element = React.createElement(Pages.Index, {});
                if (element && this.container) {
                    ReactDOM.render(element, this.container);
                }
            }
        }

    }
}