/// <reference path="./externals.d.ts" />

module Utils {
    
    export class UriHelper {
        private url: string;
        private anchorElement: HTMLAnchorElement;
        private queryString: MyMap<string> = {};

        constructor(url: string) {
            this.url = url;
            this.anchorElement = document.createElement('a');
            this.anchorElement.href = url;
            this.initQueryString();

        }

        private initQueryString() {
            if (!this.anchorElement.search || this.anchorElement.search === "") {
                return;
            }
            var queryElemes = this.anchorElement.search.substring(1).split("&");
            _.each(queryElemes, (item) => {
                var itemElems = item.split("=");
                this.queryString[itemElems[0]] = itemElems[1];
            });
        }

        get Protocol(): string {
            return this.anchorElement.protocol;
        }

        get Hostname(): string {
            return this.anchorElement.hostname;
        }

        get Port(): string {
            return this.anchorElement.port;
        }

        get Pathname(): string {
            return this.anchorElement.pathname;
        }

        get Search(): string {
            return this.anchorElement.search;
        }

        get Hash(): string {
            return this.anchorElement.hash;
        }

        get Host(): string {
            return this.anchorElement.host;
        }

        get QueryString(): MyMap<string> {
            return this.queryString;
        }
   }
}